## biboumi 4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(biboumi)

set(${PROJECT_NAME}_VERSION_MAJOR 4)
set(${PROJECT_NAME}_VERSION_MINOR 0)
set(${PROJECT_NAME}_VERSION_SUFFIX "")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra")
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage --coverage")
endif()

# Define a __FILENAME__ macro to get the filename of each file, instead of
# the full path as in __FILE__
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__FILENAME__='\"$(subst ${CMAKE_SOURCE_DIR}/,,$(abspath $<))\"'")

#
## Look for external libraries
#
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

#
## Get the software version
#
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR})
set(RPM_VERSION ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR})

if(${PROJECT_NAME}_VERSION_SUFFIX MATCHES ".+")
  set(ARCHIVE_NAME ${ARCHIVE_NAME}${${PROJECT_NAME}_VERSION_SUFFIX})
  set(RPM_VERSION ${RPM_VERSION}${${PROJECT_NAME}_VERSION_SUFFIX})
endif()

if(${PROJECT_NAME}_VERSION_SUFFIX MATCHES "^~dev$")
  # If we are on a dev version, append the hash of the current git HEAD to
  # the version
  include(FindGit)
  if(GIT_FOUND AND EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(COMMAND git --git-dir=${CMAKE_SOURCE_DIR}/.git rev-parse --short HEAD
      OUTPUT_VARIABLE GIT_REVISION
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(GIT_REVISION)
      set(${PROJECT_NAME}_VERSION_SUFFIX "${${PROJECT_NAME}_VERSION_SUFFIX} (${GIT_REVISION})")
      set(ARCHIVE_NAME ${ARCHIVE_NAME}${GIT_REVISION})
      set(RPM_VERSION ${RPM_VERSION}${GIT_REVISION})
    endif()
  endif()
endif()

set(SOFTWARE_VERSION
  ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}${${PROJECT_NAME}_VERSION_SUFFIX})

include(CheckFunctionExists)
check_function_exists(ppoll HAVE_PPOLL_FUNCTION)

# To be able to include the config.h and other files generated by cmake
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/src/")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/")

#
## Documentation
#
execute_process(COMMAND "date" "+%Y-%m-%d" OUTPUT_VARIABLE DOC_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
set(MAN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/doc/${PROJECT_NAME}.1)
set(DOC_PAGE ${CMAKE_CURRENT_SOURCE_DIR}/doc/${PROJECT_NAME}.1.rst)
if (NOT PANDOC_EXECUTABLE)
  find_program(PANDOC_EXECUTABLE NAMES pandoc
    DOC "The pandoc software, to build the man page from the rst documentation")
  if(PANDOC_EXECUTABLE)
    message(STATUS "Found Pandoc: ${PANDOC_EXECUTABLE}")
    set(WITH_DOC true)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/)
    add_custom_command(OUTPUT ${MAN_PAGE}
      COMMAND ${PANDOC_EXECUTABLE} -M date="${DOC_DATE}" -s -t man ${DOC_PAGE} -o ${MAN_PAGE}
      DEPENDS ${DOC_PAGE})
    add_custom_target(doc ALL DEPENDS ${MAN_PAGE})
  else()
    message(STATUS "Pandoc not found, documentation cannot be built")
  endif()
endif()
mark_as_advanced(PANDOC_EXECUTABLE)

# Look for litesql and enable the database if found
if(WITH_LITESQL)
  find_package(LITESQL REQUIRED)
elseif(NOT WITHOUT_LITESQL)
  find_package(LITESQL)
endif()

if(LITESQL_FOUND)
  LITESQL_GENERATE_CPP("database/database.xml"
    "biboudb"
    LITESQL_GENERATED_SOURCES)

  add_library(database STATIC src/database/database.cpp
    ${LITESQL_GENERATED_SOURCES})
  target_link_libraries(database ${LITESQL_LIBRARIES} utils)
  if(BOTAN_FOUND)
    target_link_libraries(database ${BOTAN_LIBRARIES})
  endif()
  set(USE_DATABASE TRUE)
endif()

add_subdirectory("louloulibs")
include_directories("louloulibs")

include_directories(${EXPAT_INCLUDE_DIRS})
include_directories(${ICONV_INCLUDE_DIRS})
include_directories(${LIBUUID_INCLUDE_DIRS})

# If they are found in louloulibs CMakeLists.txt, we inherite these values
if(SYSTEMD_FOUND)
  include_directories(${SYSTEMD_INCLUDE_DIRS})
endif()
if(BOTAN_FOUND)
  include_directories(SYSTEM ${BOTAN_INCLUDE_DIRS})
endif()
if(CARES_FOUND)
  include_directories(${CARES_INCLUDE_DIRS})
endif()

#
## utils
#
file(GLOB source_src_utils
    src/utils/*.[hc]pp)
# Todo, switch to target_sources(utils) when we go cmake >=3.1 only
add_library(src_utils STATIC ${source_src_utils})
target_link_libraries(src_utils logger config)
if(USE_DATABASE)
  target_link_libraries(src_utils database)
endif()

#
## irclib
#
file(GLOB source_irc
  src/irc/*.[hc]pp)
add_library(irc STATIC ${source_irc})
target_link_libraries(irc network utils logger)

#
## xmpp
#
file(GLOB source_xmpp
  src/xmpp/*.[hc]pp)
add_library(xmpp STATIC ${source_xmpp})
target_link_libraries(xmpp xmpplib bridge network utils src_utils logger)

if(USE_DATABASE)
  target_link_libraries(xmpp database)
  target_link_libraries(irc database)
endif()

#
## bridge
#
file(GLOB source_bridge
  src/bridge/*.[hc]pp)
add_library(bridge STATIC ${source_bridge})
target_link_libraries(bridge xmpp irc utils logger)

#
## Main executable
#
add_executable(${PROJECT_NAME} src/main.cpp)
target_link_libraries(${PROJECT_NAME}
  xmpp
  irc
  bridge
  utils
  src_utils
  config)
if(SYSTEMD_FOUND)
  target_link_libraries(xmpp ${SYSTEMD_LIBRARIES})
endif()

#
## Tests
#
file(GLOB source_tests
  tests/*.cpp)
add_executable(test_suite EXCLUDE_FROM_ALL
  ${source_tests})
target_link_libraries(test_suite
  xmpplib
  xmpp
  irc
  bridge
  utils
  config
  logger
  network)
if(USE_DATABASE)
  target_link_libraries(test_suite
  database)
endif()

include(ExternalProject)
ExternalProject_Add(catch
  GIT_REPOSITORY "https://lab.louiz.org/louiz/Catch.git"
  PREFIX "external"
  UPDATE_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  )
set_target_properties(catch PROPERTIES EXCLUDE_FROM_ALL TRUE)
ExternalProject_Get_Property(catch SOURCE_DIR)
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/tests/catch.hpp)
  target_include_directories(test_suite
    PUBLIC "${SOURCE_DIR}/include/"
    )
  add_dependencies(test_suite catch)
endif()
add_custom_target(check COMMAND "test_suite"
  DEPENDS test_suite biboumi)
add_custom_target(e2e COMMAND "python3" "${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/"
  DEPENDS biboumi)
add_custom_target(e2e_valgrind COMMAND "E2E_BIBOUMI_SUPP_DIR=${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/" "E2E_BIBOUMI_VALGRIND=1" "python3" "${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/"
    DEPENDS biboumi)


#
## Code coverage
#
if(CMAKE_BUILD_TYPE MATCHES Debug)
  include(CodeCoverage)
  SETUP_TARGET_FOR_COVERAGE(coverage
    test_suite
    coverage
    )
  SETUP_TARGET_FOR_COVERAGE(coverage_e2e
    make
    coverage_e2e
    e2e)
endif()

#
## Install target
#
install(TARGETS ${PROJECT_NAME} RUNTIME                     DESTINATION bin)
install(FILES   ${MAN_PAGE}                                 DESTINATION share/man/man1         OPTIONAL COMPONENT documentation)
install(FILES   ${CMAKE_CURRENT_BINARY_DIR}/biboumi.service DESTINATION lib/systemd/system     COMPONENT init)
install(FILES   conf/biboumi.cfg                            DESTINATION /etc/biboumi           COMPONENT configuration)

#
## Dist target
## Generate a release tarball from the git sources
#
add_custom_command(OUTPUT ${ARCHIVE_NAME}.tar.xz
  COMMAND git archive --prefix=${ARCHIVE_NAME}/ --format=tar HEAD^{tree}
          > ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
  # Append this specific file that is not part of the git repo
  COMMAND tar -rf ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar -P ${SOURCE_DIR}/single_include/catch.hpp --xform 's|/.*/|${ARCHIVE_NAME}/tests/|g'
  # Remove a potential existing archive
  COMMAND rm -f ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar.xz
  # Compress the archive
  COMMAND xz ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
  COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --cyan "${ARCHIVE_NAME}.tar.xz created."
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  )
add_custom_target(dist
  DEPENDS ${ARCHIVE_NAME}.tar.xz
  DEPENDS catch)

add_custom_target(rpm
  DEPENDS dist
  COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
  COMMAND rpmbuild --define "_topdir `pwd`/rpmbuild/" --define "_sourcedir `pwd`" -ba biboumi.spec
  )

if(BOTAN_FOUND)
  set(STR_WITH_BOTAN "Botan: yes")
else()
  set(STR_WITH_BOTAN "Botan: no")
endif()
if(CARES_FOUND)
  set(STR_WITH_CARES "c-ares: yes")
else()
  set(STR_WITH_CARES "c-ares: no")
endif()
add_custom_target(PrintBuildParameters ALL
  ${CMAKE_COMMAND} -E cmake_echo_color --cyan "Compiling ${PROJECT_NAME} with ${STR_WITH_BOTAN}, ${STR_WITH_CARES}")

configure_file(biboumi.h.cmake src/biboumi.h)

set(SYSTEMD_SERVICE_TYPE_DOCSTRING "The value used as the Type= in the systemd unit file.")
set(WATCHDOG_SEC_DOCSTRING "The value used as WatchdogSec= in the systemd unit file.")
if(SYSTEMD_FOUND)
  set(SYSTEMD_SERVICE_TYPE "notify" CACHE STRING ${SYSTEMD_SERVICE_TYPE_DOCSTRING})
  set(WATCHDOG_SEC "20" CACHE STRING ${WATCHDOG_SEC_DOCSTRING})
else()
  set(SYSTEMD_SERVICE_TYPE "simple" CACHE STRING ${SYSTEMD_SERVICE_TYPE_DOCSTRING})
  set(WATCHDOG_SEC "" CACHE STRING ${WATCHDOG_SEC_DOCSTRING})
endif()
set(SERVICE_USER_DOCSTRING "The value used as the User= in the systemd unit file.")
if(NOT DEFINED SERVICE_USER)
  set(SERVICE_USER "nobody" CACHE STRING ${SERVICE_USER_DOCSTRING})
endif()
set(SERVICE_GROUP_DOCSTRING "The value used as the Group= in the systemd unit file.")
if(NOT DEFINED SERVICE_GROUP)
  set(SERVICE_GROUP "nobody" CACHE STRING ${SERVICE_GROUP_DOCSTRING})
endif()
configure_file(unit/biboumi.service.cmake biboumi.service)

# The date MUST be in english format
set(ENV{LANG} "en_US.utf-8")
execute_process(COMMAND "date" "+%a %b %d %Y" OUTPUT_VARIABLE RPM_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
unset(ENV{LANG})

configure_file(packaging/biboumi.spec.cmake biboumi.spec)

=== louloulibs/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(${PROJECT_NAME}_VERSION_MAJOR 1)
set(${PROJECT_NAME}_VERSION_MINOR 0)
set(${PROJECT_NAME}_VERSION_SUFFIX "~dev")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra")

# Define a __FILENAME__ macro to get the filename of each file, instead of
# the full path as in __FILE__
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__FILENAME__='\"$(subst ${CMAKE_SOURCE_DIR}/,,$(abspath $<))\"'")

#
## Look for external libraries
#
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
include(FindEXPAT)
find_package(EXPAT REQUIRED)
find_package(ICONV REQUIRED)
find_package(LIBUUID REQUIRED)

if(WITH_LIBIDN)
  find_package(LIBIDN REQUIRED)
elseif(NOT WITHOUT_LIBIDN)
  find_package(LIBIDN)
endif()

if(WITH_SYSTEMD)
  find_package(SYSTEMD REQUIRED)
elseif(NOT WITHOUT_SYSTEMD)
  find_package(SYSTEMD)
endif()

if(WITH_BOTAN)
  find_package(BOTAN REQUIRED)
elseif(NOT WITHOUT_BOTAN)
  find_package(BOTAN)
endif()

if(WITH_CARES)
  find_package(CARES REQUIRED)
elseif(NOT WITHOUT_CARES)
  find_package(CARES)
endif()

# To be able to include the config.h file generated by cmake
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
include_directories(${EXPAT_INCLUDE_DIRS})
include_directories(${ICONV_INCLUDE_DIRS})
include_directories(${LIBUUID_INCLUDE_DIRS})

set(EXPAT_INCLUDE_DIRS ${EXPAT_INCLUDE_DIRS} PARENT_SCOPE)
set(ICONV_INCLUDE_DIRS ${ICONV_INCLUDE_DIRS} PARENT_SCOPE)
set(LIBUUID_INCLUDE_DIRS ${LIBUUID_INCLUDE_DIRS} PARENT_SCOPE)

if(LIBIDN_FOUND)
  include_directories(${LIBIDN_INCLUDE_DIRS})
  set(LIBDIN_FOUND ${LIBDIN_FOUND} PARENT_SCOPE)
  set(LIBDIN_INCLUDE_DIRS ${LIBDIN_INCLUDE_DIRS} PARENT_SCOPE)
endif()

if(SYSTEMD_FOUND)
  include_directories(${SYSTEMD_INCLUDE_DIRS})
  set(SYSTEMD_FOUND ${SYSTEMD_FOUND} PARENT_SCOPE)
  set(SYSTEMD_INCLUDE_DIRS ${SYSTEMD_INCLUDE_DIRS} PARENT_SCOPE)
endif()

if(BOTAN_FOUND)
  include_directories(SYSTEM ${BOTAN_INCLUDE_DIRS})
  set(BOTAN_FOUND ${BOTAN_FOUND} PARENT_SCOPE)
  set(BOTAN_INCLUDE_DIRS ${BOTAN_INCLUDE_DIRS} PARENT_SCOPE)
endif()

if(CARES_FOUND)
  include_directories(${CARES_INCLUDE_DIRS})
  set(CARES_FOUND ${CARES_FOUND} PARENT_SCOPE)
  set(CARES_INCLUDE_DIRS ${CARES_INCLUDE_DIRS} PARENT_SCOPE)
endif()

set(POLLER_DOCSTRING "Choose the poller between POLL and EPOLL (Linux-only)")
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 set(POLLER "EPOLL" CACHE STRING ${POLLER_DOCSTRING})
else()
 set(POLLER "POLL" CACHE STRING ${POLLER_DOCSTRING})
endif()
if((NOT ${POLLER} MATCHES "POLL") AND
    (NOT ${POLLER} MATCHES "EPOLL"))
  message(FATAL_ERROR "POLLER must be either POLL or EPOLL")
endif()

#
## utils
#
file(GLOB source_utils
  utils/*.[hc]pp)
add_library(utils STATIC ${source_utils})
target_link_libraries(utils ${ICONV_LIBRARIES})

#
## config
#
file(GLOB source_config
  config/*.[hc]pp)
add_library(config STATIC ${source_config})
target_link_libraries(config utils)

#
## logger
#
file(GLOB source_logger
  logger/*.[hc]pp)
add_library(logger STATIC ${source_logger})
target_link_libraries(logger config)

#
## network
#
file(GLOB source_network
  network/*.[hc]pp)
add_library(network STATIC ${source_network})
target_link_libraries(network logger)
if(BOTAN_FOUND)
  target_link_libraries(network ${BOTAN_LIBRARIES})
endif()
if(CARES_FOUND)
  target_link_libraries(network ${CARES_LIBRARIES})
endif()

#
## xmpplib
#
file(GLOB source_xmpplib
  xmpp/*.[hc]pp)
add_library(xmpplib STATIC ${source_xmpplib})
target_link_libraries(xmpplib network utils logger
  ${EXPAT_LIBRARIES}
  ${LIBUUID_LIBRARIES})
if(LIBIDN_FOUND)
  target_link_libraries(xmpplib ${LIBIDN_LIBRARIES})
endif()
if(SYSTEMD_FOUND)
  target_link_libraries(xmpplib ${SYSTEMD_LIBRARIES})
endif()

#
## Check if we have std::get_time
#
include(CheckCXXSourceCompiles)

check_cxx_source_compiles("
  #include <iomanip>
  int main()
  { std::get_time(nullptr, \"\"); }"
  HAS_GET_TIME)

mark_as_advanced(HAS_GET_TIME)

check_cxx_source_compiles("
  #include <iomanip>
  int main()
  { std::put_time(nullptr, \"\"); }"
  HAS_PUT_TIME)

mark_as_advanced(HAS_PUT_TIME)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/louloulibs.h.cmake ${CMAKE_BINARY_DIR}/src/louloulibs.h)

=== debian/changelog ===
biboumi (4.0-1) unstable; urgency=medium

  [ Vasudev Kamath & Jonas Smedegaard ]
  * Initial Release.
    Closes: bug#841773.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 07 Jan 2017 12:57:41 +0100

=== debian/control ===
Source: biboumi
Section: net
Priority: optional
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 licensecheck,
 cmake,
 catch,
 uuid-dev,
 pandoc,
 libexpat1-dev,
 libidn11-dev,
 libsystemd-dev,
 libc-ares-dev,
 libbotan1.10-dev
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>,
 Vasudev Kamath <vasudev@copyninja.info>
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-voip/biboumi.git
Homepage: https://lab.louiz.org/louiz/biboumi/

Package: biboumi
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: XMPP gateway to connect to IRC servers
 Biboumi is an XMPP gateway that connects to IRC servers and translates
 between the two protocols. It can be used to access IRC channels using
 any XMPP client as if these channels were XMPP MUCs.
 .
 It is written in modern C++14 and makes great efforts to have as little
 dependencies and to be as simple as possible.
 .
 The goal is to provide a way to access most of IRC features using any
 XMPP client.  It doesn’t however try to provide a complete mapping of
 the features of both worlds simply because this is not useful and most
 probably impossible.  For example all IRC modes are not all
 translatable into an XMPP features.  Some of them are (like +m (mute)
 or +o (operator) modes), but some others are IRC-specific.  If IRC is
 the limiting factor (for example you cannot have a non-ASCII nickname
 on IRC) then biboumi doesn’t try to work around this issue: it just
 enforces the rules of the IRC server by telling the user that he/she
 must choose an ASCII-only nickname.  An important goal is to keep the
 software (and its code) light and simple.

=== debian/rules ===
#!/usr/bin/make -f

# Copyright 2016 Jonas Smedegaard <dr@jones.dk>
# Copyright 2016 Vasudev Kamath <vasudev@copyninja.info>
# Description: Main Debian packaging script for biboumi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

include /usr/share/cdbs/1/class/cmake.mk

pkg = $(DEB_SOURCE_PACKAGE)

dev-deps = expat1 idn11 systemd c-ares botan1.10
CDBS_BUILD_DEPENDS += , cmake, catch, uuid-dev, pandoc
CDBS_BUILD_DEPENDS += , $(patsubst %,$(comma) lib%-dev,$(dev-deps))

DEB_CMAKE_EXTRA_FLAGS = \
 -DBOTAN_LIBRARIES="$(shell pkg-config botan-1.10 --libs-only-L)" \
 -DBOTAN_INCLUDE_DIRS="$(shell pkg-config botan-1.10 --cflags-only-I)"

DEB_MAKE_CHECK_TARGET = check

DEB_INSTALL_CHANGELOGS_ALL += CHANGELOG.rst
DEB_INSTALL_DOCS_$(pkg) += README.rst CONTRIBUTING.rst
DEB_INSTALL_EXAMPLES_$(pkg) = doc/example.conf

binary-post-install/$(pkg)::
	mkdir -p $(cdbs_curdestdir)/lib
	mv $(cdbs_curdestdir)/usr/lib/systemd $(cdbs_curdestdir)/lib

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
https://lab.louiz.org/louiz/biboumi/tags \
 .*/archive@ARCHIVE_EXT@\?ref=@ANY_VERSION@

## biboumi 5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(biboumi)

set(${PROJECT_NAME}_VERSION_MAJOR 5)
set(${PROJECT_NAME}_VERSION_MINOR 0)
set(${PROJECT_NAME}_VERSION_SUFFIX "")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
      "Build type (Release/Debug/RelWithDebInfo/MinSizeRel)" FORCE)
endif()

#
## Find optional instrumentation libraries that will be used in debug only
#
find_library(LIBASAN NAMES asan libasan.so.3 libasan.so.2 libasan.so.1)
find_library(LIBUBSAN NAMES ubsan libubsan.so.0)

#
## Set various debug flags (instrumentation libs, coverage, …)
#
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra -Wconversion")
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage --coverage")
endif()
if(LIBASAN)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=address")
endif()
if(LIBUBSAN)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=undefined")
endif()

#
## Set the software version, archive name, RPM name etc
#
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR})
set(RPM_VERSION ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR})

if(${PROJECT_NAME}_VERSION_SUFFIX MATCHES ".+")
  set(ARCHIVE_NAME ${ARCHIVE_NAME}${${PROJECT_NAME}_VERSION_SUFFIX})
  set(RPM_VERSION ${RPM_VERSION}${${PROJECT_NAME}_VERSION_SUFFIX})
endif()

if(${PROJECT_NAME}_VERSION_SUFFIX MATCHES "^~dev$")
  # If we are on a dev version, append the hash of the current git HEAD to
  # the version
  include(FindGit)
  if(GIT_FOUND AND EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(COMMAND git --git-dir=${CMAKE_SOURCE_DIR}/.git rev-parse --short HEAD
      OUTPUT_VARIABLE GIT_REVISION
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(GIT_REVISION)
      set(${PROJECT_NAME}_VERSION_SUFFIX "${${PROJECT_NAME}_VERSION_SUFFIX} (${GIT_REVISION})")
      set(ARCHIVE_NAME ${ARCHIVE_NAME}${GIT_REVISION})
      set(RPM_VERSION ${RPM_VERSION}${GIT_REVISION})
    endif()
  endif()
endif()

set(SOFTWARE_VERSION
  ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}${${PROJECT_NAME}_VERSION_SUFFIX})

#
## The rule that generates the documentation
#
execute_process(COMMAND "date" "+%Y-%m-%d" OUTPUT_VARIABLE DOC_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
set(MAN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/doc/${PROJECT_NAME}.1)
set(DOC_PAGE ${CMAKE_CURRENT_SOURCE_DIR}/doc/${PROJECT_NAME}.1.rst)
if (NOT PANDOC_EXECUTABLE)
  find_program(PANDOC_EXECUTABLE NAMES pandoc
    DOC "The pandoc software, to build the man page from the rst documentation")
  if(PANDOC_EXECUTABLE)
    message(STATUS "Found Pandoc: ${PANDOC_EXECUTABLE}")
    set(WITH_DOC true)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/)
    add_custom_command(OUTPUT ${MAN_PAGE}
      COMMAND ${PANDOC_EXECUTABLE} -M date="${DOC_DATE}" -s -t man ${DOC_PAGE} -o ${MAN_PAGE}
      DEPENDS ${DOC_PAGE})
    add_custom_target(doc ALL DEPENDS ${MAN_PAGE})
  else()
    message(STATUS "Pandoc not found, documentation cannot be built")
  endif()
endif()
mark_as_advanced(PANDOC_EXECUTABLE)

#
## Set this search path for cmake, to find our custom search modules
#
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")
find_package(ICONV REQUIRED)
find_package(LIBUUID REQUIRED)
find_package(EXPAT REQUIRED)

#
## Find all the libraries (optional or not)
#
if(WITH_LIBIDN)
  find_package(LIBIDN REQUIRED)
elseif(NOT WITHOUT_LIBIDN)
  find_package(LIBIDN)
endif()

if(WITH_SYSTEMD)
  find_package(SYSTEMD REQUIRED)
elseif(NOT WITHOUT_SYSTEMD)
  find_package(SYSTEMD)
endif()

if(WITH_BOTAN)
  find_package(BOTAN REQUIRED)
elseif(NOT WITHOUT_BOTAN)
  find_package(BOTAN)
endif()

if(NOT BOTAN_FOUND)
  find_package(GCRYPT REQUIRED)
endif()

if(WITH_UDNS)
  find_package(UDNS REQUIRED)
elseif(NOT WITHOUT_UDNS)
  find_package(UDNS)
endif()

if(WITH_LITESQL)
  find_package(LITESQL REQUIRED)
elseif(NOT WITHOUT_LITESQL)
  find_package(LITESQL)
endif()

#
## Set all the include directories, depending on what libraries are used
#
include_directories(${EXPAT_INCLUDE_DIRS})
include_directories(${ICONV_INCLUDE_DIRS})
include_directories(${LIBUUID_INCLUDE_DIRS})
if(SYSTEMD_FOUND)
  include_directories(${SYSTEMD_INCLUDE_DIRS})
endif()
if(BOTAN_FOUND)
  include_directories(SYSTEM ${BOTAN_INCLUDE_DIRS})
endif()
if(UDNS_FOUND)
  include_directories(${UDNS_INCLUDE_DIRS})
endif()

# To be able to include the config.h and other files generated by cmake
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/src/")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/")

#
## Define all the modules
#

file(GLOB source_utils
        src/utils/*.[hc]pp)
add_library(utils OBJECT ${source_utils})
add_dependencies(utils litesql_generated_sources)

file(GLOB source_irc
        src/irc/*.[hc]pp)
add_library(irc OBJECT ${source_irc})
add_dependencies(irc litesql_generated_sources)

file(GLOB source_xmpp
        src/xmpp/*.[hc]pp)
add_library(xmpp OBJECT ${source_xmpp})
add_dependencies(xmpp litesql_generated_sources)

file(GLOB source_identd
        src/identd/*.[hc]pp)
add_library(identd OBJECT ${source_identd})

file(GLOB source_bridge
        src/bridge/*.[hc]pp)
add_library(bridge OBJECT ${source_bridge})
add_dependencies(bridge litesql_generated_sources)

file(GLOB source_config
        src/config/*.[hc]pp)
add_library(config OBJECT ${source_config})

file(GLOB source_logger
        src/logger/*.[hc]pp)
add_library(logger OBJECT ${source_logger})

file(GLOB source_network
        src/network/*.[hc]pp)
add_library(network OBJECT ${source_network})

if(LITESQL_FOUND)
  LITESQL_GENERATE_CPP("database/database.xml"
          "biboudb"
          LITESQL_GENERATED_SOURCES)
  add_custom_target(litesql_generated_sources SOURCES ${LITESQL_GENERATED_SOURCES})

  add_library(database OBJECT src/database/database.cpp ${LITESQL_GENERATED_SOURCES})
  add_dependencies(database litesql_generated_sources)

  include_directories(database ${LITESQL_INCLUDE_DIRS})
  set(USE_DATABASE TRUE)
else()
  add_library(database OBJECT "")
  add_custom_target(litesql_generated_sources)
endif()

#
## Define the executables
#

## main
add_executable(${PROJECT_NAME} src/main.cpp
        $<TARGET_OBJECTS:utils>
        $<TARGET_OBJECTS:config>
        $<TARGET_OBJECTS:logger>
        $<TARGET_OBJECTS:network>
        $<TARGET_OBJECTS:xmpp>
        $<TARGET_OBJECTS:bridge>
        $<TARGET_OBJECTS:irc>
        $<TARGET_OBJECTS:identd>
        $<TARGET_OBJECTS:database>)

## test_suite
file(GLOB source_tests
  tests/*.cpp)
add_executable(test_suite ${source_tests}
        $<TARGET_OBJECTS:utils>
        $<TARGET_OBJECTS:config>
        $<TARGET_OBJECTS:logger>
        $<TARGET_OBJECTS:network>
        $<TARGET_OBJECTS:xmpp>
        $<TARGET_OBJECTS:bridge>
        $<TARGET_OBJECTS:irc>
        $<TARGET_OBJECTS:identd>
        $<TARGET_OBJECTS:database>)
set_target_properties(test_suite PROPERTIES EXCLUDE_FROM_ALL TRUE)

#
## Link the executables with their libraries
#
target_link_libraries(${PROJECT_NAME}
        ${ICONV_LIBRARIES}
        ${LIBUUID_LIBRARIES}
        ${EXPAT_LIBRARY})
target_link_libraries(test_suite
        ${ICONV_LIBRARIES}
        ${LIBUUID_LIBRARIES}
        ${EXPAT_LIBRARY})
if(SYSTEMD_FOUND)
  target_link_libraries(${PROJECT_NAME} ${SYSTEMD_LIBRARIES})
  target_link_libraries(test_suite ${SYSTEMD_LIBRARIES})
endif()
if(BOTAN_FOUND)
  target_link_libraries(${PROJECT_NAME} ${BOTAN_LIBRARIES})
  target_link_libraries(test_suite ${BOTAN_LIBRARIES})
elseif(GCRYPT_FOUND)
  target_link_libraries(${PROJECT_NAME} ${GCRYPT_LIBRARIES})
  target_link_libraries(test_suite ${GCRYPT_LIBRARIES})
endif()
if(UDNS_FOUND)
  target_link_libraries(${PROJECT_NAME} ${UDNS_LIBRARIES})
  target_link_libraries(test_suite ${UDNS_LIBRARIES})
endif()
if(LIBIDN_FOUND)
  target_link_libraries(${PROJECT_NAME} ${LIBIDN_LIBRARIES})
  target_link_libraries(test_suite ${LIBIDN_LIBRARIES})
endif()
if(USE_DATABASE)
  target_link_libraries(${PROJECT_NAME} ${LITESQL_LIBRARIES})
  target_link_libraries(test_suite ${LITESQL_LIBRARIES})
endif()

# Define a __FILENAME__ macro with the relative path (from the base project directory)
# of each source file
file(GLOB_RECURSE source_all src/*.[hc]pp tests/*.[hc]pp)
foreach(file ${source_all})
  file(RELATIVE_PATH shorter_file ${CMAKE_CURRENT_SOURCE_DIR} ${file})
  set_property(SOURCE ${file} APPEND PROPERTY COMPILE_DEFINITIONS __FILENAME__="${shorter_file}")
endforeach()

#
## Add a rule to download the catch unit test framework
#
include(ExternalProject)
ExternalProject_Add(catch
  GIT_REPOSITORY "https://lab.louiz.org/louiz/Catch.git"
  PREFIX "external"
  UPDATE_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  )
set_target_properties(catch PROPERTIES EXCLUDE_FROM_ALL TRUE)
ExternalProject_Get_Property(catch SOURCE_DIR)
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/tests/catch.hpp)
  target_include_directories(test_suite
    PUBLIC "${SOURCE_DIR}/include/"
    )
  add_dependencies(test_suite catch)
endif()

#
## Add some custom rules to launch the tests
#
add_custom_target(check COMMAND "test_suite"
  DEPENDS test_suite biboumi)
set_target_properties(check PROPERTIES EXCLUDE_FROM_ALL TRUE)
add_custom_target(e2e COMMAND "python3" "${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/"
  DEPENDS biboumi)
set_target_properties(e2e PROPERTIES EXCLUDE_FROM_ALL TRUE)
add_custom_target(e2e_valgrind COMMAND "E2E_BIBOUMI_SUPP_DIR=${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/" "E2E_BIBOUMI_VALGRIND=1" "python3" "${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/"
    DEPENDS biboumi)
if(CMAKE_BUILD_TYPE MATCHES Debug)
  include(CodeCoverage)
  SETUP_TARGET_FOR_COVERAGE(coverage_check
    ./test_suite
    coverage_test_suite)
  add_dependencies(coverage_check test_suite)

  SETUP_TARGET_FOR_COVERAGE(coverage_e2e
    python3
    coverage_e2e
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/end_to_end/)
  add_dependencies(coverage_e2e biboumi)

  ADD_CUSTOM_TARGET(coverage
    COMMAND ${LCOV_PATH} -a coverage_e2e.info -a coverage_test_suite.info -o coverage_total.info

    COMMAND ${GENHTML_PATH} -o coverage_total coverage_total.info

    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
endif()
add_custom_target(everything DEPENDS test_suite biboumi)

#
## Install target
#
install(TARGETS ${PROJECT_NAME} RUNTIME                     DESTINATION bin)
install(FILES   ${MAN_PAGE}                                 DESTINATION share/man/man1         OPTIONAL COMPONENT documentation)
install(FILES   ${CMAKE_CURRENT_BINARY_DIR}/biboumi.service DESTINATION lib/systemd/system     COMPONENT init)
file(GLOB policy_files conf/*policy.txt)
install(FILES   ${policy_files}                             DESTINATION /etc/biboumi           COMPONENT configuration)

#
## Dist target
## Generate a release tarball from the git sources
#
add_custom_command(OUTPUT ${ARCHIVE_NAME}.tar.xz
  COMMAND git archive --prefix=${ARCHIVE_NAME}/ --format=tar HEAD^{tree}
          > ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
  # Append this specific file that is not part of the git repo
  COMMAND tar -rf ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar -P ${SOURCE_DIR}/single_include/catch.hpp --xform 's|/.*/|${ARCHIVE_NAME}/tests/|g'
  # Remove a potential existing archive
  COMMAND rm -f ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar.xz
  # Compress the archive
  COMMAND xz ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
  COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --cyan "${ARCHIVE_NAME}.tar.xz created."
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  )
add_custom_target(dist
  DEPENDS ${ARCHIVE_NAME}.tar.xz
  DEPENDS catch)

add_custom_target(rpm
  DEPENDS dist
  COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
  COMMAND rpmbuild --define "_topdir `pwd`/rpmbuild/" --define "_sourcedir `pwd`" -ba biboumi.spec
  )

#

=== debian/changelog ===
biboumi (5.0-2) unstable; urgency=medium

  * Fix build with option -DCMAKE_BUILD_TYPE=Release.
    Closes: Bug#866225. Thanks to Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 28 Jun 2017 20:26:57 +0200

biboumi (5.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    + Add identd server.
    + Add persistent option for channels, to behave like an IRC bouncer.
    + Use udns library (not c-ares) for asynchronous DNS resolution.
    + Update MAM implementation to version 6.0 (namespace mam:2).
    + Limit MAM to 100 messages per channel by default.
    + Properly handle multiline topics.
    + Support overriding configuration options by environment values.
    + Support customizing Botan TLS policies per IRC server.
    + IRC channel config form now available via MUC config.
    + Notices starting with "#channel" now treated as welcome messages.

  [ Jonas Smedegaard ]
  * Declare compliance with Debian Policy 4.0.0.
  * Modernize Vcs-Browser field:
    + Use git (not cgit) in path.
  * Update package relations:
    + Build-depend on libudns-dev (not libc-ares-dev).
    + Build-depend on libgcrypt20-dev.
    + Stop build-depend on libbotan1.10-dev (unused: Too old).
  * Drop patch 2002: Fixed upstream.
  * Unfuzz patch 2001.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 24 Jun 2017 10:15:23 +0200

biboumi (4.3-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    + Works with botan 2.x (not only botan 1.11.x).
    + Fix build without LiteSQL available.
    + Fix segmentation fault connecting to IRC server on undefined port.

  [ Jonas Smedegaard ]
  * Update watch file:
    + Fix mangle upstream filename (lacked versioning, confusing uscan).
  * Modernize cdbs:
    + Do copyright-check in maintainer script (not during build).
    + Stop build-depend on licensecheck.
  * Drop patch cherry-picked upstream and now applied.
  * Drop patch cherry-picked upstream but now mysteriously gone from
    upstream master branch.
  * Update copyright info:
    + Extend copyright for my parts to cover current year.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 21 May 2017 12:03:04 +0200

biboumi (4.0-2) unstable; urgency=medium

  * Fix set proper group (and explicitly set user too, while at it).
    Closes: Bug#854252. Thanks to Jonas Wielicki and Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 04 Mar 2017 20:37:49 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
- licensecheck,
  cmake,
  catch,
  uuid-dev,
@@ -12,14 +11,14 @@
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
- libc-ares-dev,
- libbotan1.10-dev
+ libudns-dev,
+ libgcrypt20-dev
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-voip/biboumi.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Homepage: https://lab.louiz.org/louiz/biboumi/
 
 Package: biboumi

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-# Copyright 2016 Jonas Smedegaard <dr@jones.dk>
+# Copyright 2016-2017 Jonas Smedegaard <dr@jones.dk>
 # Copyright 2016 Vasudev Kamath <vasudev@copyninja.info>
 # Description: Main Debian packaging script for biboumi
 #
@@ -18,17 +18,18 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/rules/utils.mk
-
 include /usr/share/cdbs/1/class/cmake.mk
 
 pkg = $(DEB_SOURCE_PACKAGE)
 
-dev-deps = expat1 idn11 systemd c-ares botan1.10
+# TODO: Build-dpend on libbotan1.11-dev or libbotan2.0 when available
+dev-deps = expat1 idn11 systemd udns gcrypt20
 CDBS_BUILD_DEPENDS += , cmake, catch, uuid-dev, pandoc
 CDBS_BUILD_DEPENDS += , $(patsubst %,$(comma) lib%-dev,$(dev-deps))
 
 DEB_CMAKE_EXTRA_FLAGS = \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DSERVICE_USER=nobody -DSERVICE_GROUP=nogroup \
  -DBOTAN_LIBRARIES="$(shell pkg-config botan-1.10 --libs-only-L)" \
  -DBOTAN_INCLUDE_DIRS="$(shell pkg-config botan-1.10 --cflags-only-I)"

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?archive\.tar\.bz2\?ref=(\d[\d.]*)%@PACKAGE@-$1.tar.bz2%" \
https://lab.louiz.org/louiz/biboumi/tags \
 .*/archive@ARCHIVE_EXT@\?ref=@ANY_VERSION@

## biboumi 7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 project(biboumi)
 
-set(${PROJECT_NAME}_VERSION_MAJOR 5)
-set(${PROJECT_NAME}_VERSION_MINOR 0)
+set(${PROJECT_NAME}_VERSION_MAJOR 7)
+set(${PROJECT_NAME}_VERSION_MINOR 2)
 set(${PROJECT_NAME}_VERSION_SUFFIX "")
 
 if(NOT CMAKE_BUILD_TYPE)
@@ -14,13 +14,13 @@
 #
 ## Find optional instrumentation libraries that will be used in debug only
 #
-find_library(LIBASAN NAMES asan libasan.so.3 libasan.so.2 libasan.so.1)
+find_library(LIBASAN NAMES asan libasan.so.4 libasan.so.3 libasan.so.2 libasan.so.1)
 find_library(LIBUBSAN NAMES ubsan libubsan.so.0)
 
 #
 ## Set various debug flags (instrumentation libs, coverage, …)
 #
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra -Wconversion")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra -Wconversion -fvisibility=hidden -fvisibility-inlines-hidden")
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
   set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage --coverage")
 endif()
@@ -124,10 +124,16 @@
   find_package(UDNS)
 endif()
 
-if(WITH_LITESQL)
-  find_package(LITESQL REQUIRED)
-elseif(NOT WITHOUT_LITESQL)
-  find_package(LITESQL)
+if(WITH_SQLITE3)
+  find_package(SQLITE3 REQUIRED)
+elseif(NOT WITHOUT_SQLITE3)
+  find_package(SQLITE3)
+endif()
+
+if(WITH_POSTGRESQL)
+  find_package(PQ REQUIRED)
+elseif(NOT WITHOUT_POSTGRESQL)
+  find_package(PQ)
 endif()
 
 #
@@ -158,17 +164,14 @@
 file(GLOB source_utils
         src/utils/*.[hc]pp)
 add_library(utils OBJECT ${source_utils})
-add_dependencies(utils litesql_generated_sources)
 
 file(GLOB source_irc
         src/irc/*.[hc]pp)
 add_library(irc OBJECT ${source_irc})
-add_dependencies(irc litesql_generated_sources)
 
 file(GLOB source_xmpp
         src/xmpp/*.[hc]pp)
 add_library(xmpp OBJECT ${source_xmpp})
-add_dependencies(xmpp litesql_generated_sources)
 
 file(GLOB source_identd
         src/identd/*.[hc]pp)
@@ -177,7 +180,6 @@
 file(GLOB source_bridge
         src/bridge/*.[hc]pp)
 add_library(bridge OBJECT ${source_bridge})
-add_dependencies(bridge litesql_generated_sources)
 
 file(GLOB source_config
         src/config/*.[hc]pp)
@@ -191,20 +193,23 @@
         src/network/*.[hc]pp)
 add_library(network OBJECT ${source_network})
 
-if(LITESQL_FOUND)
-  LITESQL_GENERATE_CPP("database/database.xml"
-          "biboudb"
-          LITESQL_GENERATED_SOURCES)
-  add_custom_target(litesql_generated_sources SOURCES ${LITESQL_GENERATED_SOURCES})
-
-  add_library(database OBJECT src/database/database.cpp ${LITESQL_GENERATED_SOURCES})
-  add_dependencies(database litesql_generated_sources)
-
-  include_directories(database ${LITESQL_INCLUDE_DIRS})
+option(DEBUG_SQL_QUERIES
+       "If set to true, every SQL statement executed will be logged and timed"
+       OFF)
+if(SQLITE3_FOUND OR PQ_FOUND)
+  file(GLOB source_database
+          src/database/*.[hc]pp)
+  add_library(database OBJECT ${source_database})
+
+  if(SQLITE3_FOUND)
+    include_directories(database ${SQLITE3_INCLUDE_DIRS})
+  endif()
+  if(PQ_FOUND)
+    include_directories(database ${PQ_INCLUDE_DIRS})
+  endif()
   set(USE_DATABASE TRUE)
 else()
   add_library(database OBJECT "")
-  add_custom_target(litesql_generated_sources)
 endif()
 
 #
@@ -269,8 +274,14 @@
   target_link_libraries(test_suite ${LIBIDN_LIBRARIES})
 endif()
 if(USE_DATABASE)
-  target_link_libraries(${PROJECT_NAME} ${LITESQL_LIBRARIES})
-  target_link_libraries(test_suite ${LITESQL_LIBRARIES})
+  if(SQLITE3_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${SQLITE3_LIBRARIES})
+    target_link_libraries(test_suite ${SQLITE3_LIBRARIES})
+  endif()
+  if(PQ_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${PQ_LIBRARIES})
+    target_link_libraries(test_suite ${PQ_LIBRARIES})
+endif()
 endif()
 
 # Define a __FILENAME__ macro with the relative path (from the base project directory)
@@ -368,7 +379,3 @@
 add_custom_target(rpm
   DEPENDS dist
   COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
-  COMMAND rpmbuild --define "_topdir `pwd`/rpmbuild/" --define "_sourcedir `pwd`" -ba biboumi.spec
-  )
-
-#

=== debian/changelog ===
biboumi (7.2-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Fix ship with empty dir /var/lib/biboumi to get it removed on purge.
    Closes: Bug#886932. Thanks to Andreas Beckmann.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 01 Feb 2018 20:03:54 +0100

biboumi (7.1-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    Closes: Bug#887838. Thanks to W. Martin Borgert.

  [ Jonas Smedegaard ]
  * Update package relations: Build-depend on libpq-dev.
  * Add patch 1001 to tighten shell code.
  * Install sqlite dumb script as example script.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 23 Jan 2018 11:29:57 +0100

biboumi (6.1-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Fix update list of cmake files in the public-domain.
      Closes: Bug#877536. Thanks to Florent Le Coz <louiz@louiz.org>.
  * Build with user/group _biboumi, and create account in postinst:
    Newly enabled SQlite support requires a real home.
    Closes: 877533. Thanks to Vasudev Kamath and Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Oct 2017 23:58:22 +0200

biboumi (6.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update package relations: Build-depend on libsqlite3-dev.
  * Unfuzz patch 2001.
  * Declare compliance with Debian Policy 4.1.1.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Sep 2017 01:30:26 +0200

biboumi (5.0-3) unstable; urgency=medium

  * Have binary package provide virtual package ident-server.
  * Fix watch file.
  * Declare compliance with Debian Policy 4.1.0.
  * Tighten lintian overrides regarding License-Reference.
  * Advertise DEP3 format in patch headers.
  * Update copyright info: Fix include License section BSD-3-clause.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 14 Sep 2017 14:50:39 +0200

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,21 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
- cmake,
- catch,
- uuid-dev,
- pandoc,
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
  libudns-dev,
- libgcrypt20-dev
+ libgcrypt20-dev,
+ libsqlite3-dev,
+ libpq-dev,
+ cmake,
+ catch,
+ uuid-dev,
+ pandoc
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Homepage: https://lab.louiz.org/louiz/biboumi/
@@ -24,7 +26,9 @@
 Package: biboumi
 Architecture: any
 Depends: ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
+ adduser,
+Provides: ident-server
 Description: XMPP gateway to connect to IRC servers
  Biboumi is an XMPP gateway that connects to IRC servers and translates
  between the two protocols. It can be used to access IRC channels using

=== debian/rules ===
--- 
+++ 
@@ -23,13 +23,15 @@
 pkg = $(DEB_SOURCE_PACKAGE)
 
 # TODO: Build-dpend on libbotan1.11-dev or libbotan2.0 when available
-dev-deps = expat1 idn11 systemd udns gcrypt20
-CDBS_BUILD_DEPENDS += , cmake, catch, uuid-dev, pandoc
-CDBS_BUILD_DEPENDS += , $(patsubst %,$(comma) lib%-dev,$(dev-deps))
+dev-bdeps = expat1 idn11 systemd udns gcrypt20 sqlite3 pq
+bdeps = $(patsubst %,$(comma) lib%-dev,$(dev-bdeps))
+bdeps +=, cmake, catch, uuid-dev, pandoc
+
+CDBS_BUILD_DEPENDS +=, $(bdeps)
 
 DEB_CMAKE_EXTRA_FLAGS = \
  -DCMAKE_BUILD_TYPE=Release \
- -DSERVICE_USER=nobody -DSERVICE_GROUP=nogroup \
+ -DSERVICE_USER=_biboumi -DSERVICE_GROUP=_biboumi \
  -DBOTAN_LIBRARIES="$(shell pkg-config botan-1.10 --libs-only-L)" \
  -DBOTAN_INCLUDE_DIRS="$(shell pkg-config botan-1.10 --cflags-only-I)"
 
@@ -37,7 +39,10 @@
 
 DEB_INSTALL_CHANGELOGS_ALL += CHANGELOG.rst
 DEB_INSTALL_DOCS_$(pkg) += README.rst CONTRIBUTING.rst
-DEB_INSTALL_EXAMPLES_$(pkg) = doc/example.conf
+DEB_INSTALL_EXAMPLES_$(pkg) = doc/example.conf scripts/*
+
+# Create empty dir to have it removed on purge - see bug#886932
+DEB_INTALL_DIRS_$(pkg) = /var/lib/biboumi
 
 binary-post-install/$(pkg)::
 	mkdir -p $(cdbs_curdestdir)/lib

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%/louiz/biboumi/repository/@ANY_VERSION@/archive(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
https://lab.louiz.org/louiz/biboumi/tags \
 /louiz/biboumi/repository/@ANY_VERSION@/archive@ARCHIVE_EXT@

## biboumi 8.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,19 @@
 
 project(biboumi)
 
-set(${PROJECT_NAME}_VERSION_MAJOR 7)
-set(${PROJECT_NAME}_VERSION_MINOR 2)
+set(${PROJECT_NAME}_VERSION_MAJOR 8)
+set(${PROJECT_NAME}_VERSION_MINOR 3)
 set(${PROJECT_NAME}_VERSION_SUFFIX "")
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
+        message(FATAL_ERROR "GCC version must be at least 5.0.")
+    endif()
+elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
+        message(FATAL_ERROR "Clang version must be at least 3.4.")
+    endif()
+endif()
 
 if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
@@ -308,7 +318,7 @@
 ExternalProject_Get_Property(catch SOURCE_DIR)
 if(NOT EXISTS ${CMAKE_SOURCE_DIR}/tests/catch.hpp)
   target_include_directories(test_suite
-    PUBLIC "${SOURCE_DIR}/include/"
+    PUBLIC "${SOURCE_DIR}/single_include/"
     )
   add_dependencies(test_suite catch)
 endif()
@@ -368,14 +378,3 @@
   # Remove a potential existing archive
   COMMAND rm -f ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar.xz
   # Compress the archive
-  COMMAND xz ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
-  COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --cyan "${ARCHIVE_NAME}.tar.xz created."
-  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-  )
-add_custom_target(dist
-  DEPENDS ${ARCHIVE_NAME}.tar.xz
-  DEPENDS catch)
-
-add_custom_target(rpm
-  DEPENDS dist
-  COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}

=== debian/changelog ===
biboumi (8.3-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Dominik George <natureshadow@debian.org>  Mon, 22 Oct 2018 13:07:00 +0200

biboumi (8.3-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).

  [ Jonas Smedegaard ]
  * Fix typo in watch file usage comment.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Jun 2018 22:40:30 +0200

biboumi (8.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Dominik George ]
  * Remove empty /usr/lib from package.

  [ Jonas Smedegaard ]
  * Update watch file:
    + Fix typo in usage comment.
    + Update download pattern.
  * Modernize cdbs: Stop resolve build-dependencies in rules file.
  * Update package relations:
    + Tighten to Build-depend (explicitly and) versioned on gcc.
  * Update Vcs-* fields: Source hosted at Salsa.debian.org now.
  * Declare compliance with Debian Policy 4.1.4.
  * Unfuzz patch 2001.
  * Add patch 1002 to allow identd with systemd.
    Closes: Bug#895944. Thanks to Dominik George.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 May 2018 16:42:16 +0200

biboumi (7.2-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Dominik George <natureshadow@debian.org>  Sun, 15 Apr 2018 22:56:59 +0200

biboumi (7.2-2) unstable; urgency=medium

  * Update package relations:
    + Build-depend on libbotan-2-dev (not libgcrypt20-dev).
      Closes: Bug#857658. Thanks to Michel Le Bihan.
  * Drop custom (and wrong) Botan-related build options.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 02 Mar 2018 01:09:42 +0100

biboumi (6.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports. (Closes: #872562)

 -- W. Martin Borgert <debacle@debian.org>  Mon, 01 Jan 2018 12:09:00 +0000

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
+ gcc (>= 4:5),
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
  libudns-dev,
- libgcrypt20-dev,
+ libbotan-2-dev,
  libsqlite3-dev,
  libpq-dev,
  cmake,
@@ -17,10 +18,11 @@
  pandoc
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
- Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.1.1
-Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
+ Vasudev Kamath <vasudev@copyninja.info>,
+ Dominik George <natureshadow@debian.org>
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/pkg-voip-team/biboumi.git
+Vcs-Browser: https://salsa.debian.org/pkg-voip-team/biboumi
 Homepage: https://lab.louiz.org/louiz/biboumi/
 
 Package: biboumi

=== debian/watch ===
# run "uscan --report" to check or "gbp import-orig --uscan" to update
version=4
https://lab.louiz.org/louiz/biboumi/tags \
 /louiz/biboumi/-/archive/[^/]+/biboumi@ANY_VERSION@@ARCHIVE_EXT@
